var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import * as React from 'react';
import styles from './FabricUiGroupedList.module.scss';
import { Icon, initializeIcons } from "office-ui-fabric-react";
import { SelectionMode } from 'office-ui-fabric-react/lib/Selection';
import { GroupedList } from 'office-ui-fabric-react/lib/GroupedList';
import { groupBy, findIndex } from '@microsoft/sp-lodash-subset';
var FabricUiGroupedList = /** @class */ (function (_super) {
    __extends(FabricUiGroupedList, _super);
    function FabricUiGroupedList(props) {
        var _this = _super.call(this, props) || this;
        _this._onRenderCell = function (_nestingDepth, item, itemIndex) {
            return (React.createElement("div", null,
                React.createElement("span", { style: { fontSize: "large", paddingLeft: "25px" } }, item.Title),
                React.createElement("br", null)));
        };
        initializeIcons();
        _this.state = {
            items: [],
            result: [],
        };
        return _this;
    }
    FabricUiGroupedList.prototype.componentWillMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var groupedlistitems;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, GetGroupedListData(this.props.SiteURL)];
                    case 1:
                        groupedlistitems = _a.sent();
                        console.log(groupedlistitems);
                        this.setState({ result: groupedlistitems });
                        return [2 /*return*/];
                }
            });
        });
    };
    FabricUiGroupedList.prototype._generateIGroupsFromArray = function (sortedItems) {
        var groupedByIconCategory = groupBy(sortedItems, function (i) { return i.IconCategory; });
        var groups = [];
        var _loop_1 = function (IconCategory) {
            groups.push({
                name: IconCategory,
                key: IconCategory,
                startIndex: findIndex(sortedItems, function (i) { return i.IconCategory === IconCategory; }),
                count: groupedByIconCategory[IconCategory].length,
                isCollapsed: findIndex(sortedItems, function (i) { return i.IconCategory === IconCategory; }) == 0 ? false : true
            });
        };
        for (var IconCategory in groupedByIconCategory) {
            _loop_1(IconCategory);
        }
        return groups;
    };
    FabricUiGroupedList.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement("h3", null, "Fabric UI Grouped List with Icon Category"),
            React.createElement("hr", null),
            React.createElement(GroupedList, { className: styles.groupcolor, items: this.state.result, onRenderCell: this._onRenderCell, groups: this._generateIGroupsFromArray(this.state.result), groupProps: groupedListProps, selection: this._selection, selectionMode: SelectionMode.none })));
    };
    return FabricUiGroupedList;
}(React.Component));
export default FabricUiGroupedList;
export var GetGroupedListData = function (webURL) { return __awaiter(_this, void 0, void 0, function () {
    var items;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                items = [];
                return [4 /*yield*/, fetch(webURL + "/_api/web/lists/Getbytitle('FabricUIGroupedList')/items", {
                        method: 'GET',
                        mode: 'cors',
                        credentials: 'include',
                        headers: new Headers({
                            'Content-Type': 'application/json',
                            'Accept': 'application/json',
                            'Access-Control-Allow-Origin': '*',
                            'Cache-Control': 'no-cache',
                            'pragma': 'no-cache',
                        }),
                    }).then(function (response) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, response.json()];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    }); }); })
                        .then(function (data) { return __awaiter(_this, void 0, void 0, function () {
                        var i;
                        return __generator(this, function (_a) {
                            console.log(data);
                            if (data.value.length > 0) {
                                for (i = 0; i < data.value.length; i++) {
                                    items.push({
                                        Title: data.value[i].Title,
                                        IconCategory: data.value[i].IconCategory,
                                    });
                                }
                            }
                            return [2 /*return*/];
                        });
                    }); }).catch(function (error) { return console.error(error); })];
            case 1:
                _a.sent();
                return [4 /*yield*/, items];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
var onRenderHeader = function (props) {
    if (props) {
        var toggleCollapse = function () {
            props.onToggleCollapse(props.group);
        };
        return (React.createElement("div", null,
            React.createElement(Icon, { style: { marginBottom: "10px", fontSize: 25, cursor: "pointer" }, iconName: "ChevronRightSmall", onClick: toggleCollapse }),
            React.createElement(Icon, { style: { paddingLeft: "16px", fontSize: 37, cursor: "pointer" }, iconName: props.group.name, onClick: toggleCollapse }, props.group.isCollapsed ? 'Expand' : 'Collapse')));
    }
    return null;
};
var groupedListProps = {
    onRenderHeader: onRenderHeader
};
//# sourceMappingURL=FabricUiGroupedList.js.map